//*****************************************************************************
//
//	Fuckings til elgen odd og alle dens venner
//
//*****************************************************************************


//*****************************************************************************
//	Attributes
//*****************************************************************************
//float4x4		g_ProjMatrix				: PROJ;
float4x4		g_WorldMatrix				: WORLD;
float4x4		g_WorldViewProjMatrix		: VIEWPROJ;
float4x4		g_WorldViewMatrix				: VIEW;
float				g_fTime							: TIME;
float3			g_EyePoint					: EYEPOS;
//float3			g_LightPoint				: LIGHTPOS;

//*****************************************************************************
//	Constants
//*****************************************************************************

const float g_FocusDepth = -2.0f;
const float g_FocalLength = 1.2f;

//*****************************************************************************
//	Textures
//*****************************************************************************


texture EnvTexture : TEXTURE1
<
	string ResourceName = "lightcube_twister.dds";
	string Type = "CUBE" ;
> ;


//*****************************************************************************
//  Texture Samplers
//*****************************************************************************



sampler EnvSampler = sampler_state
{
		Texture = (EnvTexture) ;
		MinFilter = LINEAR  ;
		MagFilter = LINEAR  ;
} ;


//*****************************************************************************
//*****************************************************************************
//*****************************************************************************
//*****************************************************************************
//  Bobs shaders
//*****************************************************************************
//*****************************************************************************
//*****************************************************************************
//*****************************************************************************

struct bobsVS_In
{
	float4 Position		: POSITION0 ;
//	float4 Color			: COLOR0 ;
	float3 Normal			: NORMAL;
};

struct bobsVS_Out
{
	float4 Position		: POSITION ;
//	float4 Color			: COLOR0 ;
	float3 Normal			: TEXCOORD0;
	float1 colorAdd		: TEXCOORD1 ;
	float3 Pos				: TEXCOORD2 ;
} ;


bobsVS_Out bobsVS (bobsVS_In In)
{
	bobsVS_Out Out;

	Out.Position = mul(In.Position, g_WorldViewProjMatrix);
	Out.Normal = mul(In.Normal, (float3x3)g_WorldMatrix);
	Out.Pos = mul(In.Position, g_WorldMatrix);

	float3 p = mul(In.Position, g_WorldViewMatrix);
	float dist = 0.08f*(p.z - g_FocusDepth);
	Out.colorAdd = (1.0f - 1.0f/exp(dist*dist));

//	Out.Color = In.Color;
	return Out;
}

struct bobsPS_In
{
//	float4 Color		: COLOR0 ;
	float3 Normal			: TEXCOORD0;
	float1 colorAdd		: TEXCOORD1 ;
	float3 Pos				: TEXCOORD2 ;
} ;

struct bobsPS_Out
{
	float4 Color	: COLOR0 ;
} ;


bobsPS_Out ballPS (bobsPS_In In)
{
	bobsPS_Out Out;

	float3 normal = normalize(In.Normal) ;

	float3 i = normalize(g_EyePoint - In.Pos);
	float3 reflect = i - 2*(i - dot(normal, i)*normal);	

	float4 EnvCol = float4(1.2f, 0.7f, 0.45f, 1.0f)*texCUBE(EnvSampler, reflect);

	const float3 lightPoint = float3(0.0f, 0.0f, 20.0f);
 	float dotValue = max( 0, dot(normalize(lightPoint - In.Pos.xyz), normal) );
	const float3 lightPoint2 = float3(0.0f, 10.0f, -13.0f);
 	dotValue += max( 0, dot(normalize(lightPoint2 - In.Pos.xyz), normal) );

	Out.Color = max(0.18f, dotValue)*EnvCol
								 + (pow(dotValue, 122) + In.colorAdd)*float4(1,1,1,1);
	Out.Color.a = 1.0f;	
	return Out;
}


//*****************************************************************
//*****************************************************************
//*****************************************************************
//
// Techniques
//
//*****************************************************************
//*****************************************************************
//*****************************************************************

technique ZineSphere
{
	pass P0
    {
			ZEnable = true ;
			ZWriteEnable = true;
			CullMode = NONE;
			AlphaBlendEnable = false;
			VertexShader = compile vs_2_0 bobsVS();
			PixelShader = compile ps_2_0 ballPS();
    }
}
